Building on MacOSX

From Apache OpenOffice Wiki
< Documentation‎ | Building Guide AOO
Revision as of 15:44, 14 February 2019 by Jimjag (Talk | contribs)

(diff) ← Older revision | Latest revision (diff) | Newer revision → (diff)
Jump to: navigation, search

Template:Documentation/Building Guide AOO TOC

Overview

Building Apache OpenOffice from source code follows the platform independent building guide when the build requirements outlined below are fulfilled.

General build requirements

Please see the general build requirements page.

Mac specific requirements for building AOO 4.1 (and newer)

What Where to get / Remarks
Mac OS X version 10.7 (aka Lion) or later provided by Apple
Xcode version 7 or later. Use the App Store application to get and install it. For Xcode 7 (or newer) some extra steps are needed.

You can also download it free of charge, but a registration at the Apple Developer Connection site is required for that.

MacOSX SDK SDKs compatible with OSX 10.7 are automatically provided by installing XCode 7 or newer. That most recent compatible SDK is 10.11; SDKs for 10.12 and above are not supported due to Apple's deprecation of Quicktime, which is needed for vcl.
gnutar OSX<=10.8 contains the tool directly, for OSX>=10.9 some extra steps are needed.

Requirements for Xcode 7 (or newer)

What Where to get / Remarks
Xcode commandline tools run this command in a terminal
sudo xcode-select --install
autoconf Run these commands in a terminal
curl -OL http://ftpmirror.gnu.org/autoconf/autoconf-2.69.tar.bz2
tar xvjf autoconf-2.69.tar.bz2
pushd autoconf-2.69
./configure --prefix=/usr/local
make
sudo make install
popd

Alternatively, you can also install via MacPorts

OSX 10.9 (or newer) specific requirements

What Where to get / Remarks
gnutar Run these commands in a terminal
curl -OL http://ftpmirror.gnu.org/tar/tar-1.27.tar.bz2
tar xvjf tar-1.27.tar.bz2
pushd tar-1.27
./configure --prefix=/usr/local
make
sudo make install
sudo ln -s /usr/local/bin/tar /usr/local/bin/gnutar
popd

Alternatively, you can also install via MacPorts

Reference Build System

The reference build system for AOO 4.1.x and 4.2.x is a macOS VM with 6x3.33 cores and 16GB of RAM. It is currently running macOS 10.13 (High Sierra) with Xcode 10, but requires the MacOSX10.11.sdk (SDK 10.12 and above do not support QuickTime, which is a requirement for AOO). We use xcodelegacy to install the required SDK into Xcode (You could also use Xcode7 directly). This setup is also configured to allow us to product the "Official" Community builds for macOS/OSX and supports versions as old as 10.7 (Lion). On this platform it takes 2-3 hours for a full build.

If building for your own setup, some of the below may not be required.

3rd Party Requirements

Installed in /usr/local:

You will notice that the recommended version of epm for OS X is 4.3 (or later); This is because previous versions required the long deprecated PackageMaker application (as well as PackageMaker being installed in a hardcoded location). Starting with epm 4.3, the official OS X pkgbuild utility is supported, removing the need for PackageMaker. AOO specific versions of epm and dmake are available on Github.

Installed in /opt/local via MacPorts:

  • autoconf (symlinked to /usr/local/bin)
  • gnutar (symlinked to /usr/local/bin)
  • perl5 (symlinked to /usr/local/bin)
  • subversion
  • git

You will also need to install the required Perl packages noted in the general build page since OS X does not include them by default. If you don't want to mix System and User modifications, you can use MacPorts/HomeBrew to install Perl and use this user-land version for these extra packages.

Local Environment Requirements:

  • Make sure that /usr/local/bin is in your PATH.
  • Set and export JAVA_HOME (export JAVA_HOME=$(/usr/libexec/java_home -v 1.7))
  • Ensure that these env variables are also correct (and exported):
    • ANT_HOME=/usr/local/share/java/apache-ant
    • LIBRARY_PATH=/usr/local/lib
    • C_INCLUDE_PATH=/usr/local/include
    • CPLUS_INCLUDE_PATH=/usr/local/include

Configure and Build

Run this command in a terminal
./configure   \
       --enable-verbose \
       --with-openldap \
       --enable-category-b \
       --enable-bundled-dictionaries \
       --enable-wiki-publisher \
       --without-junit \
       --with-jdk-home="$JAVA_HOME" \
       --with-ant-home="$ANT_HOME" \
       --with-epm=/usr/local/bin/epm \
       --with-dmake-path=/usr/local/bin/dmake \
       --without-stlport \
       --with-package-format="dmg" \
       --disable-systray \
       --with-alloc=internal \
       --with-lang="${LANGS}" 

The LANGS env variable should contain the list of languages you wish to build for (e.g. "en-GB en-US es eu fi").

Continue with the standard, platform independent build instructions. Copies of the official build scripts (and their corresponding config.log outputs) can be found here.

Personal tools